﻿namespace TBL.CSharp.Serialization
{
    /// <summary>
    /// 可使用代理序列化的对象接口
    /// <para>此类对象可以使用另一个可序列化对象来代理自身的序列化</para>
    /// </summary>
    public interface IProxiedSerializable
    {
        /// <summary>
        /// 代理序列化
        /// </summary>
        /// <returns>可参与序列化的此对象代理</returns>
        object ProxiedSerialize();

        /// <summary>
        /// 代理反序列化
        /// </summary>
        /// <param name="proxy">可以用作反序列化的代理对象</param>
        void ProxiedDeserialize(object proxy);
        
        /// <summary>
        /// 当此对象反序列化时，是否应该使用构造方法初始化
        /// <para>如果为否，反序列化时创建的对象将不会使用构造方法</para>
        /// </summary>
        bool IsShouldInitializeWhenDeserialize();
    }
}