﻿using System.Collections;
using System.Collections.Generic;

namespace TBL.CSharp.Utilities;

/// <summary>
/// 非托管元素列表接口
/// </summary>
public unsafe readonly struct UnsafeList<T> : IList<T> where T : unmanaged
{
    /// <summary>
    /// 首元素地址
    /// </summary>
    public readonly T* Header;

    /// <summary>
    /// 元素计数
    /// </summary>
    public readonly int Length;

    public UnsafeList(T* header, int length)
    {
        Header = header;
        Length = length;
    }

    public IEnumerator<T> GetEnumerator()
    {
        for (var i = 0; i < Length; i++)
        {
            yield return this[i];
        }
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return GetEnumerator();
    }

    public void Add(T item)
    {
        throw new System.NotImplementedException();
    }

    public void Clear()
    {
        throw new System.NotImplementedException();
    }

    public bool Contains(T item)
    {
        for (var i = 0; i < Length; i++)
        {
            if (Equals(Header[i], item))
                return true;
        }
        return false;
    }

    public void CopyTo(T[] array, int arrayIndex)
    {
        throw new System.NotImplementedException();
    }

    public bool Remove(T item)
    {
        throw new System.NotImplementedException();
    }

    public int Count => Length;

    public bool IsReadOnly => false;
    
    public int IndexOf(T item)
    {
        for (var i = 0; i < Length; i++)
        {
            if (Equals(Header[i], item))
                return i;
        }
        return -1;
    }

    public void Insert(int index, T item)
    {
        throw new System.NotImplementedException();
    }

    public void RemoveAt(int index)
    {
        throw new System.NotImplementedException();
    }

    public T this[int index]
    {
        get => Header[index];
        set => Header[index] = value;
    }
}